<!-- 
PluginName: Tags
PluginUrl: https://ioctopus.online/tags-plugin
Version: 1.20
Propose to set up: true

-->




<script>
{
  console.log('Tags Plugin')

  const tagReg = new RegExp('(#[\\p{XID_Continue}\\p{Extended_Pictographic}\\p{Emoji_Component}\\p{L}\\w\\-\\p{Emoji_Presentation}]+)', 'gu')
  // const tagReg = /(#[\p{L}\w\-\p{Emoji_Presentation}]+)/gu


  /**
   * Хештеги по idшникам веток
   * @type {Record<string, string[]>}
   */
  const tagsOfAllBranches = {}


  // ########  ##     ## ######## ########  #######  ##    ##
  // ##     ## ##     ##    ##       ##    ##     ## ###   ##
  // ##     ## ##     ##    ##       ##    ##     ## ####  ##
  // ########  ##     ##    ##       ##    ##     ## ## ## ##
  // ##     ## ##     ##    ##       ##    ##     ## ##  ####
  // ##     ## ##     ##    ##       ##    ##     ## ##   ###
  // ########   #######     ##       ##     #######  ##    ##
  const tagButton = {

    components: {
      buttonus: ioctopus.getButtonusComponent(),
    },


    props: {
      tag: String,
      toggle: Boolean,
    },


    data() {

      return {
        moving: {
          startEvent: null,
          startButton: { x: 0, y: 0 },
          lastEvent: null,
          moved: false,
          length: 0,
          startGlobalPos: { x: 0 },
          pos: { x: 0, y: 0 },
          process: false,
        },
        containerSize: { x: 0, y: 0 },
      }
    },


    computed: {

      containerStyles() {
        const styles = {}

        if (this.containerSize.x) {
          styles.width = this.containerSize.x + 'px'
        }

        if (this.containerSize.y) {
          styles.height = this.containerSize.y + 'px'
        }

        return styles
      },

    },


    methods: {

      movingStart(e) {
        this.moving.startEvent = e
        this.moving.lastEvent = e
        this.moving.length = 0
        this.moving.process = true

        this.containerSize.x = this.$el.clientWidth
        this.containerSize.y = this.$el.clientHeight

        const bounds = this.$el.getBoundingClientRect()
        this.moving.startButton.x = e.pageX - bounds.x
        this.moving.startButton.y = e.pageY - bounds.y

        this.moving.startGlobalPos.x = bounds.left

        const onMove = ($event) => {
          this.onMove($event)
        }

        const onMoveStop = ($event) => {
          document.removeEventListener('mousemove', onMove)
          document.removeEventListener('mouseup', onMoveStop)
          this.onMoveStop($event)
        }

        document.addEventListener('mousemove', onMove)
        document.addEventListener('mouseup', onMoveStop)

        this.$emit('move-start')
      },


      onMove(e) {

        const delta = {
          x: e.pageX - this.moving.lastEvent.pageX,
          y: e.pageX - this.moving.lastEvent.pageY,
        }

        this.moving.length += Math.sqrt(delta.x * delta.x + delta.y * delta.y)

        this.moving.lastEvent = e
        this.moveButtonToMouse()

        this.$emit('move')
      },


      onMoveStop() {
        this.moving.process = false
        this.moving.startEvent = null
        this.moving.lastEvent = null
        this.containerSize.x = 0
        this.containerSize.y = 0
        this.moving.pos.x = 0
        this.moving.pos.y = 0
        this.$emit('move-stop')
      },


      toggleEmit($event) {
        if (this.moving.length > 5) return
        this.$emit('update:toggle', $event)
      },


      moveButtonToMouse() {
        const bounds = this.$el.getBoundingClientRect()
        const currentDelta = {
          x: this.moving.lastEvent.pageX - bounds.x,
          y: this.moving.lastEvent.pageY - bounds.y,
        }
        this.moving.pos.x = currentDelta.x - this.moving.startButton.x
        this.moving.pos.y = currentDelta.y - this.moving.startButton.y
      },

    },


    template: `
    <div
      :class="['tags--button-container', {
        'tags--button-container-process': moving.process,
      }]"
      :style="containerStyles"
      @contextmenu="$emit('contextmenu', $event)"
    >
      <buttonus
        :style="{
          left: moving.pos.x+'px',
          top: moving.pos.y+'px',
        }"
        :label="tag"
        :toggle="toggle"
        @mousedown="movingStart"
        @update:toggle="toggleEmit"
      />
    </div>
    `
  }



  // ##      ## #### ########   ######   ######## ########
  // ##  ##  ##  ##  ##     ## ##    ##  ##          ##
  // ##  ##  ##  ##  ##     ## ##        ##          ##
  // ##  ##  ##  ##  ##     ## ##   #### ######      ##
  // ##  ##  ##  ##  ##     ## ##    ##  ##          ##
  // ##  ##  ##  ##  ##     ## ##    ##  ##          ##
  //  ###  ###  #### ########   ######   ########    ##
  let widget = new Vue({

    components: {
      buttonus: ioctopus.getButtonusComponent(),
      tagButton,
    },


    data() {
      ioctopus.$store.getters.mapData.plugins.tags = ioctopus.$store.getters.mapData.plugins.tags || {
        sorting: {},
      }

      const selected = {
        '': false,
      }


      const mode = window.localStorage.getItem('tags-mode') || 'or'


      return {
        tags: [],
        selected,
        _init: false,
        buttonClicked: false,
        sorting: ioctopus.$store.getters.mapData.plugins.tags.sorting,
        mode, // or|and
      }
    },


    mounted() {
      let hashTagsHash = window.location.hash || ''
      if (hashTagsHash && hashTagsHash.match(/^#tags=/)) {
        hashTagsHash = hashTagsHash.replace(/^#tags=/, '')
        let tags = hashTagsHash.split('|')
        this.buttonClicked = true
        for (let tag of tags) {
          this.$set(this.selected, '#'+tag, true)
        }
      }
    },


    //  ######   #######  ##     ## ########  ##     ## ######## ######## ########
    // ##    ## ##     ## ###   ### ##     ## ##     ##    ##    ##       ##     ##
    // ##       ##     ## #### #### ##     ## ##     ##    ##    ##       ##     ##
    // ##       ##     ## ## ### ## ########  ##     ##    ##    ######   ##     ##
    // ##       ##     ## ##     ## ##        ##     ##    ##    ##       ##     ##
    // ##    ## ##     ## ##     ## ##        ##     ##    ##    ##       ##     ##
    //  ######   #######  ##     ## ##         #######     ##    ######## ########
    computed: {

      clearButtonVisible() {
        for (let tag in this.selected) {
          if (tag && this.selected[tag]) return true
        }
        return false
      },


      unsortedList() {
        const list = []

        // Чтобы только что добавленные теги сортировались по алфавиту
        for (let tag of this.tags) {
          let sorting = this.sorting[tag]
          if (typeof sorting === 'undefined') {
            this.getSortingForUnsorted(tag)
          }
        }


        for (let tag of this.tags) {
          if (!tag) continue

          let sorting = this.sorting[tag]
          if (typeof sorting === 'undefined') {
            sorting = 100000
          }

          list.push({
            tag,
            sorting,
          })
        }

        return list
      },


      sortedTags() {
        return this.unsortedList.sort((a, b) => {
          if (a.sorting > b.sorting) return 1
          if (a.sorting < b.sorting) return -1
          return 0
        })
      },


      modeButtonText() {

        let modeLabel

        // Filter mode (and, or)
        if (this.mode === 'and') {
          modeLabel = wdpro.translate({
            // IOtranslate
            '': 'And',
            'fr': 'Et',
            'es': 'Y',
            'pt': 'E',
            'ua': 'І',
            'ch': '和',
            'jp': 'そして',
            'ru': 'И',
          }) || 'And'
        }

        // Or
        else {
          modeLabel = wdpro.translate({
            // IOtranslate
            '': 'Or',
            'fr': 'Ou',
            'es': 'O',
            'pt': 'Ou',
            'ua': 'Або',
            'ch': '或者',
            'jp': 'または',
            'ru': 'Или',
          }) || 'Or'
        }


        return modeLabel

        // return wdpro.translate({
        //   // IOtranslate
        //   '': `Mode: ${modeLabel}`,
        //   'fr': `Mode: ${modeLabel}`,
        //   'es': `Modo: ${modeLabel}`,
        //   'pt': `Modo: ${modeLabel}`,
        //   'ua': `Режим: ${modeLabel}`,
        //   'ch': `模式：${modeLabel}`,
        //   'jp': `モード：${modeLabel}`,
        //   'ru': `Режим: ${modeLabel}`,
        // })

      },

    },


    // ##      ##    ###    ########  ######  ##     ##
    // ##  ##  ##   ## ##      ##    ##    ## ##     ##
    // ##  ##  ##  ##   ##     ##    ##       ##     ##
    // ##  ##  ## ##     ##    ##    ##       #########
    // ##  ##  ## #########    ##    ##       ##     ##
    // ##  ##  ## ##     ##    ##    ##    ## ##     ##
    //  ###  ###  ##     ##    ##     ######  ##     ##
    watch: {

      tags(tags, prevTags) {
        prevTags = ioctopus._.cloneDeep(prevTags)

        for (let tag of tags) {
          if (typeof this.selected[tag] === 'undefined') {
            this.$set(this.selected, tag, false)
          }
        }

        if (!this._init) {
          this._init = true
          return
        }

        this.updateBranchVisible()
      },


      selected: {
        deep: true,
        handler(selected) {
          this.updateBranchVisible()
        },
      },

    },


    // #    # ###### ##### #    #  ####  #####   ####
    // ##  ## #        #   #    # #    # #    # #
    // # ## # #####    #   ###### #    # #    #  ####
    // #    # #        #   #    # #    # #    #      #
    // #    # #        #   #    # #    # #    # #    #
    // #    # ######   #   #    #  ####  #####   ####
    methods: {

      getSortingForUnsorted(unsortedTag) {

        let sortedTags = this.tags.map(tag => {
          return {
            tag,
            sorting: this.sorting[tag],
          }
        })
        sortedTags.sort((a, b) => {
          if (a.sorting > b.sorting) return 1
          if (a.sorting < b.sorting) return -1
          return 0
        })

        let sortingForUnsortedTag = 0
        for (let element of sortedTags) {

          if (sortingForUnsortedTag) {
            element.sorting ++
            this.sorting[element.tag] ++
            continue
          }

          else if (element.tag < unsortedTag) {
            sortingForUnsortedTag = element.sorting + 1
            this.sorting[unsortedTag] = sortingForUnsortedTag
          }
        }

        return sortingForUnsortedTag
      },


      sortAlphabetically() {

        let sortedTags = this.tags.map(tag => tag)

        sortedTags.sort((a, b) => {
          if (a > b) return 1
          if (a < b) return -1
          return 0
        })

        let sorting = 0
        for (let tag of sortedTags) {
          sorting ++
          this.sorting[tag] = sorting
        }

        if (JSON.stringify(this.beforeMoveSorting) !== JSON.stringify(this.sorting)) {
          this.save()
        }
      },


      updateBranchVisible() {
        if (!this.buttonClicked) return

        const visibleTags = []
        for (let tag of this.tags) {
          if (this.selected[tag]) {
            visibleTags.push(tag)
          }
        }

        ioctopus.$store.commit('setVisibleModeForce', !!visibleTags.length)

        // Есть выбранные хэштеги
        if (visibleTags && visibleTags.length) {

          // Each branch
          for (let branchId in ioctopus.structureInfo.byId) {

            /** @type {structureInfoItem} */
            const item = ioctopus.structureInfo.byId[branchId]

            // Root
            if (!item.parentId) continue

            /**
             * @type {string[]}
             */
            const branchTags = tagsOfAllBranches[branchId]

            let visible = false
            if (branchTags) {

              const visibleOr = branchTags.filter(n => visibleTags.indexOf(n) !== -1).length

              if (this.mode === 'or') {
                visible = visibleOr
              }

              if (visibleOr && this.mode === 'and') {
                visible = true
                for (let tag of visibleTags) {
                  if (branchTags.indexOf(tag) === -1) {
                    visible = false
                    // break
                  }
                }
              }

            }


            ioctopus.setBranchVisible(branchId, visible)
          }

          // Hash
          const hashTags = visibleTags.map(tag => tag.replace(/#/g, ''))
          const hash = 'tags='+hashTags.join('|')
          window.location.hash = hash
        }

        // Нет выбранных хэштегов
        else {
          for (let branchId in ioctopus.structureInfo.byId) {
            ioctopus.setBranchVisible(branchId, false)
          }
          window.location.hash = ''
        }
      },


      toggle(tag, selected) {
        if (typeof selected === 'undefined') {
          selected = !this.selected[tag]
        }
        this.buttonClicked = true
        this.$set(this.selected, tag, selected)
      },


      clear() {
        this.buttonClicked = true

        for (let tag in this.selected) {
          if (this.selected[tag]) {
            this.$set(this.selected, tag, false)
          }
        }
      },


      sortButtons(movingTag) {

        // Получаем передвигаемую кнопку
        let movingButton = this.$refs['button' + movingTag][0]

        // X всех кнопок
        let buttons = []

        // Перебираем кнопки
        for (let tag of this.tags) {
          const $button = this.$refs['button' + tag][0]
          const $el = $button.$el.childNodes[0]
          const bounds = $el.getBoundingClientRect()
          buttons.push({
            tag,
            x: bounds.left,
            w: bounds.width,
            y: bounds.top,
            h: bounds.height,
          })
        }

        buttons.sort((a, b) => {
          if (a.y > b.y + b.h/2) return 1
          if (a.y < b.y - b.h/2) return -1
          if (a.x > b.x) return 1
          if (a.x < b.x) return -1
          return 0
        })

        let i = 0
        let sorting = {}
        for (let button of buttons) {
          sorting[button.tag] = i
          i ++
        }

        this.$set(this, 'sorting', sorting)
        movingButton.moveButtonToMouse()
        this.$nextTick(() => {
          movingButton.moveButtonToMouse()
        })
      },


      onMoveStart() {
        console.error('onMoveStart')
        this.beforeMoveSorting = ioctopus._.cloneDeep(this.sorting)
      },


      saveIfWasMoved(tag) {
        const $button = this.$refs['button' + tag][0]
        if (JSON.stringify(this.beforeMoveSorting) !== JSON.stringify(this.sorting)) {
          this.save()
        }
      },


      save() {
        ioctopus.$store.getters.mapData.plugins.tags.sorting = this.sorting
        ioctopus.save()
      },


      toggleMode() {
        if (this.mode === 'and') this.mode = 'or'
        else this.mode = 'and'

        window.localStorage.setItem('tags-mode', this.mode)

        this.updateBranchVisible()
      },


      getModeTitle() {
        return wdpro.translate({
          // IOtranslate
          '': 'Mode of filter\nAND - select branches which have all selected tags\nOR - select branches which have at least one selected tag',
          'fr': 'Mode de filtre\nET - sélectionnez les branches qui ont tous les tags sélectionnés\nOU - sélectionnez les branches qui ont au moins un tag sélectionné',
          'es': 'Modo de filtro\nY - seleccionar ramas que tengan todas las etiquetas seleccionadas\nO - seleccionar ramas que tengan al menos una etiqueta seleccionada',
          'pt': 'Modo de filtro\nE - selecione ramos que tenham todas as tags selecionadas\nOU - selecione ramos que tenham pelo menos uma tag selecionada',
          'ua': 'Режим фільтру\nІ - вибирати гілки, у яких є всі вибрані теги\nАБО - гілки, у яких є хоча б один вибраний тег',
          'ch': '过滤器模式\n与 - 选择具有所有选定标签的分支\n或 - 选择至少具有一个选定标签的分支',
          'jp': 'フィルターモード\nAND - 選択したタグをすべて持つブランチを選択する\nOR - 少なくとも1つの選択したタグを持つブランチを選択する',
          'ru': 'Режим фильтра\nИ - выбирать ветки, у которых есть все выбранные теги\nИЛИ - ветки, у которых есть хотя бы один выбранный тег',
        })
      },


      onContextMenu($event) {
        const rows = []

        rows.push([{
          label: 'Sort alphabetically',
          icon: 'fas fa-sort-alpha-down',
          click: () => {
            ioctopus.$store.dispatch('closeContextMenu');
            this.sortAlphabetically()
          },
        }])

        ioctopus.$store.dispatch('openContextMenu', {
          rows,
          $event,
          useEventPos: true,
          type: 'tags-tag',
        })
      },

    },


    template: `
      <div class="tags--container">

        <!-- Tags -->
        <div class="tags--buttons-container" ref="buttons-container">
          <tag-button
            v-for="element in sortedTags"
            :key="'tags-'+element.tag"
            :ref="'button' + element.tag"
            :tag="element.tag"
            :toggle="selected[element.tag]"
            @update:toggle="toggle(element.tag, $event)"
            @move-start="onMoveStart"
            @move="sortButtons(element.tag)"
            @move-stop="saveIfWasMoved(element.tag)"
            @contextmenu.prevent="onContextMenu"
          />

        </div>


        <!-- Clear -->
        <buttonus
          icon="fas fa-times"
          :enabled="clearButtonVisible"
          title="Clear filter"
          @click="clear"
        />


        <!-- Mode -->
        <buttonus
          icon="fas fa-sort"
          :label="modeButtonText"
          :title="getModeTitle()"
          @click="toggleMode"
        />

      </div>
    `,

  })



  // Text Filter
  ioctopus.addViewTextFilter(({text}) => {
    return text.replace(tagReg, '<span class="a" onclick="window.toggleTag(this); event.stopPropagation();">$1</span>')
  })


  // Toggle tag
  window.toggleTag = (tagElement) => {
    const tag = tagElement.innerHTML
    widget.toggle(tag)
  }


  // On MapData
  ioctopus.$on('map-data', mapData => {

    console.error('mapData', mapData)

    widget.$set(widget, 'tags', [])

    const branchTags = []

    // Обновляем список добавленных тэгов
    const add = tag => {
      if (widget.tags.indexOf(tag) !== -1) return
      widget.tags.push(tag)
      branchTags.push(tag)
    }

    const addList = list => {
      if (!list) return

      for (let item of list) {
        if (item.content && item.content.text) {
          const tags = item.content.text.match(tagReg)

          if (tags) {
            for(let tag of tags) {
              add(tag)
            }
          }

          if (item.id) {
            if (tags && tags.length) {
              tagsOfAllBranches[item.id.toString()] = tags
            }
            else {
              delete tagsOfAllBranches[item.id.toString()]
            }
          }
        }

        addList(item.items)
      }
    }

    addList(mapData.items)
  })


  // Autocompletion
  {
    let openedDialog
    let lastAutocompletes = null
    let preventOpenForTime
    const closeTagsDialog = (preventFastOpen) => {
      if (preventFastOpen) {
        preventOpenForTime = new Date().getTime() + 100
      }

      if (openedDialog) {
        openedDialog.close()
        openedDialog = null
      }
      lastAutocompletes = null
    }


    // http://jsfiddle.net/timdown/dBgHn/1/
    const getWord = () => {
      var sel, word = "";
      if (window.getSelection && (sel = window.getSelection()).modify) {
        var selectedRange = sel.getRangeAt(0);
        sel.collapseToStart();
        sel.modify("move", "backward", "word");
        sel.modify("move", "backward", "character");
        sel.modify("extend", "forward", "character");
        sel.modify("extend", "forward", "word");

        word = sel.toString();

        // Restore selection
        sel.removeAllRanges();
        sel.addRange(selectedRange);
      } else if ( (sel = document.selection) && sel.type != "Control") {
        var range = sel.createRange();
        range.collapse(true);
        range.expand("word");
        console.log('range', range)
        word = range.text;
      }

      return word
    }


    // https://stackoverflow.com/questions/3561493/is-there-a-regexp-escape-function-in-javascript
    const escapeRegex = (string) => {
      return string.replace(/[/\-\\^$*+?.()|[\]{}]/g, '\\$&');
    }



    ioctopus.$on('text-input', async ({ el, $el, $event }) => {

      if ($event.code === 'Enter') return
      if ($event.code === 'ArrowUp') return
      if ($event.code === 'ArrowDown') return
      if ($event.code === 'ArrowLeft') return
      if ($event.code === 'ArrowRight') return

      const word = getWord()
      if (!/^#/.test(word)) {
        closeTagsDialog()
        return
      }

      const reg = new RegExp(`^${escapeRegex(word)}`)

      const autocompletes = []

      for (let tag of widget.tags) {
        if (reg.test(tag)) {
          autocompletes.push(tag)
        }
      }


      // Blur
      const onBlur = () => {
        closeTagsDialog(true)
      }
      el.$once('blur', onBlur)


      // Branch
      const $branch = ioctopus.$store.getters.getBranchById(el.id())


      // Not changed
      if (lastAutocompletes && lastAutocompletes.join(',') === autocompletes.join(',')) {
        return
      }
      lastAutocompletes = autocompletes


      // Close dialog
      closeTagsDialog()


      if (!autocompletes.length) return

      // Open dialog
      console.log('Open dialog')
      openedDialog = await $branch.openDialog({
        component: {

          components: {
            buttonus: ioctopus.getButtonusComponent(),
          },


          data() {
            return {
              autocompletes,
              selectedI: -1,
              // stopPropagation: false,
              destroyed: false,
            }
          },


          mounted() {
            console.error('mounted')

            const keydown = (e) => this.onKeyDown(e)
            const keypress = (e) => this.onKeyPress(e)
            const keyup = (e) => this.onKeyUp(e)

            document.addEventListener('keydown', keydown, true)
            document.addEventListener('keypress', keypress, true)
            document.addEventListener('keyup', keyup, true)
          },


          destroyed() {
            document.removeEventListener('keydown', this.onKeyDown)
            document.removeEventListener('keypress', this.onKeyPress)
            document.removeEventListener('keyup', this.onKeyUp)
            this.destroyed = true
          },


          methods: {

            onKeyDown($event) {
              if (this.destroyed) return

              if ($event.code === 'Enter' && !$event.shiftKey) {
                $event.stopPropagation()
                $event.preventDefault()
                return
              }

              if ($event.code === 'ArrowDown' || $event.code === 'ArrowUp') {
                if ($event.code === 'ArrowDown') {
                  this.selectedI ++
                  // $event.stopPropagation()
                  // this.stopPropagation = true
                }
                if ($event.code === 'ArrowUp') {
                  this.selectedI --
                  // $event.stopPropagation()
                  // this.stopPropagation = true
                }


                if (this.selectedI >= this.autocompletes.length) {
                  this.selectedI = 0
                }

                if (this.selectedI < 0) {
                  this.selectedI = this.autocompletes.length - 1
                }

                $event.stopPropagation()
                $event.preventDefault()
              }

            },


            onKeyPress($event) {
              if (this.destroyed) return
              // if (this.stopPropagation) {
              //   $event.stopPropagation()
              //   this.stopPropagation = false
              // }

              if (this.selectedI !== -1) {
                if ($event.key === 'Enter' && !$event.shiftKey) {
                  $event.stopPropagation()
                  $event.preventDefault()
                }
              }
            },


            onKeyUp($event) {
              if (this.destroyed) return

              if (this.selectedI !== -1) {
                if ($event.key === 'Enter' && !$event.shiftKey) {
                  $event.stopPropagation()
                  $event.preventDefault()
                  this.applyCurrent()
                }
              }
            },


            applyCurrent() {
              if (this.selectedI === -1) return
              this.applyI(this.selectedI)
            },


            applyI(i){
              const autocomplete = this.autocompletes[i]
              this.applyAutocomplete(autocomplete)
            },


            applyAutocomplete(autocomplete) {
              console.error('applyAutocomplete', autocomplete)

              let sel
              if (window.getSelection && (sel = window.getSelection()).modify) {
                var selectedRange = sel.getRangeAt(0);
                sel.collapseToStart();
                sel.modify("move", "backward", "word");
                sel.modify("move", "backward", "character");
                sel.modify("extend", "forward", "character");
                sel.modify("extend", "forward", "word");

                // insertText
                document.execCommand('insertText', false, autocomplete)

                el.emitResize()

                closeTagsDialog()
              }
            },

          },

          template: `<div>
            <div
              v-for="(autocomplete, index) in autocompletes"
              class="tags-autocomplete-item"
            >
              <buttonus
                :label="autocomplete"
                :actived="index === selectedI"
                @click="applyAutocomplete(autocomplete)"
                @mousedown.prevent=""
              />
            </div>
          </div>`,
        },
      })
    })
  }


  // On platform ready
  ioctopus.addElement({
    name: 'tags',
    instance: widget,
  })

}


/**
 * @typedef {Object} structureInfoItem
 * @property {number} id
 * @property {{ toEnd: number, fromStart: number }} pos
 * @property {taskComputed} task
 * @property {number} [parentId]
 * @property {number} [parentTempId]
 * @property {boolean} [end]
 */
</script>



<style>
.tags--container {
  display: flex;
}

.tags--buttons-container {
  display: flex;
  flex-wrap: wrap;
  justify-content: center;
}

.tags--button-container {

}

.tags--button-container-process {
  position: relative;
  z-index: 10;
}

.tags--container .buttonus--button:hover {
  background: var(--panel--main--hover--background);
  color: var(--panel--main--hover--color);
}

.tags--container .buttonus--button {
  color: var(--panel--main--color);
}

.tags--container .buttonus--button.buttonus--active {
  background: var(--panel--main--active--background);
  color: var(--panel--main--active--color);
}

.tags-autocomplete-item .buttonus {
  width: 100%;
}

@media (max-width: 768px) {
  .tags--reset {
    display: none;
  }
}
</style>

